using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace USB_HID_1
{
    public partial class Form1 : Form
    {
        [DllImport(@"c:\VcSharp\USB_HID_1\USB_HID_1\DLL_Holder\AtUsbHid.dll")]
        public static extern Boolean findHidDevice(uint VendorID, uint ProductID);

        [DllImport(@"c:\VcSharp\USB_HID_1\USB_HID_1\DLL_Holder\AtUsbHid.dll")]
        public static extern void closeDevice();

        [DllImport(@"c:\VcSharp\USB_HID_1\USB_HID_1\DLL_Holder\AtUsbHid.dll")]
        private static extern Boolean writeData(byte[] buf);

        [DllImport(@"c:\VcSharp\USB_HID_1\USB_HID_1\DLL_Holder\AtUsbHid.dll")]
        private static extern Boolean readData(byte[] buffer);

        [DllImport(@"c:\VcSharp\USB_HID_1\USB_HID_1\DLL_Holder\AtUsbHid.dll")]
        private static extern int hidRegisterDeviceNotification(IntPtr hWnd);

        [DllImport(@"c:\VcSharp\USB_HID_1\USB_HID_1\DLL_Holder\AtUsbHid.dll")]
        private static extern void hidUnregisterDeviceNotification(IntPtr hWnd);

        [DllImport(@"c:\VcSharp\USB_HID_1\USB_HID_1\DLL_Holder\AtUsbHid.dll")]
        private static extern int isMyDeviceNotification(uint dwData);

        [DllImport(@"c:\VcSharp\USB_HID_1\USB_HID_1\DLL_Holder\AtUsbHid.dll")]
        private static extern Boolean setFeature(byte type, byte direction, uint length);

        private static string strBuffer;
        private bool IsConnected;
        private int guiTimerCount;
        private const int RECBUFMAX = 255;
        private byte[] receiveBuffer = new byte[RECBUFMAX];
        private int receiveIndex;
        private IntPtr hWndParent;
        

        public Form1()
        {
            InitializeComponent();
            RegisterHidNotification();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void connectToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }
        
        private void ConnectDevice()
        {
            bool test = findHidDevice(0x03EB, 0x2013);
            if (test)
                textBoxStatus.Text = "ConnectDevice: Device found";
            else
                textBoxStatus.Text = "ConnectDevice: Device not found";
            
            IsConnected = test;
        }

        /// <summary>
        /// When the user selects the send, 
        /// 1. read textBoxSend, verify it is ascii characters, even length
        /// 2. add header, length, crc
        /// 3. transmit
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SendData(string sendData)
        {
            int index;
            byte[] xmitbuffer = new byte[50];
            byte[] sbuffer = new byte[100];
            byte[] packet = new byte[60];
            byte[] buf = new byte[16];
            
            receiveIndex = 0;

            if (IsConnected == false)
            {
                ConnectDevice();
                if (IsConnected == false)
                {
                    textBoxStatus.Text = "Error: the system is not connected";
                    textBoxReceive.Text += "Error: the system is not connected\r\n";
                    return;
                }
            }

            textBoxReceive.Text += "SendData\r\n";
            guiTimerCount = 0;
            
            memcpy(ref sbuffer, sendData, sendData.Length);

            index = ConvertAsciiHexToBin(ref xmitbuffer, ref sbuffer, sendData.Length);

            int length = CreatePacket(ref packet, ref xmitbuffer, index);
            index = 0;
            int org_length = length;
            while (length != 0)
            {
                for (int i = 0; i < 16; i++)
                {
                    int idx = i + index;
                    buf[i] = (idx < org_length) ? packet[idx] : (byte)0;
                }
                writeData(buf);
                if (length > 16)
                {
                    index += 16;
                    length -= 16;
                }
                else
                {
                    length = 0;
                }
            }

            MyStartTimer();
        }

        private void readSingleBlockToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DlgRdSngBlk f = new DlgRdSngBlk();
            Buffer = "";
            f.ShowDialog();

            if (Buffer.Length == 0)
                return;

            textBoxReceive.Text = "Read Block\r\n";
            SendData(Buffer);
        }

        private void readMultiBlockToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DlgRdMul f = new DlgRdMul();
            Buffer = "";
            f.ShowDialog();

            if (Buffer.Length == 0)
                return;

            textBoxReceive.Text = "Read Multi-Block\r\n";
            SendData(Buffer);
        }

        private void writeBlockToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DlgWrtBlk f = new DlgWrtBlk();
            Buffer = "";
            f.ShowDialog();

            if (Buffer.Length == 0)
                return;

            textBoxReceive.Text = "Write Block\r\n";
            SendData(Buffer);
        }

        private void writeMultiBlockToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DlgWrtMul f = new DlgWrtMul();
            Buffer = "";
            f.ShowDialog();

            if (Buffer.Length == 0)
                return;

            textBoxReceive.Text = "Write Multi-Block\r\n";
            SendData(Buffer);
       }

        private void inventoryToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string strFlag = "83";
            string strCmd = "01";
            string strAFI = "00";
            string strPacket = strFlag + strCmd + strAFI;

            textBoxReceive.Text = "Inventory\r\n";
            SendData(strPacket);
        }

        private void audioLEDSettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private void audioActivateToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private void readerVersionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string strFlag = "80";
            string strCmd = "E0";
            string strPacket = strFlag+strCmd;

            textBoxReceive.Text = "Reader Version\r\n";
            SendData(strPacket);
        }

        private void MyStartTimer()
        {
            timer1.Enabled = true;
            timer1.Interval = 50; //milliseconds
            timer1.Start();
        }

        private void MyKillTimer()
        {
            timer1.Stop();
            timer1.Enabled = false;
        }

        private void memcpy(ref byte[] sbuffer, string strAscii, int length)
        {
            for (int i = 0; i < length; i++)
            {
                char ch = strAscii[i];
                sbuffer[i] = (byte)ch;
            }
        }

        private int ConvertAsciiHexToBin(ref byte[] ptrOut, ref byte[] ptrIn, int length)
        {
            int rtnLength = 0;
            byte upper_nibble, lower_nibble, total_nibble;
            int inputIndex = 0;

            while (length != 0)
            {
                length--;
                upper_nibble = ConvertAsciiToHex(ptrIn[inputIndex++]);
                if (length != 0)
                    length--;
                lower_nibble = ConvertAsciiToHex(ptrIn[inputIndex++]);
                total_nibble = upper_nibble;
                total_nibble <<= 4;
                total_nibble &= 0xF0;
                total_nibble |= lower_nibble;
                ptrOut[rtnLength++] = total_nibble;
            }
            return rtnLength;
        }


        private byte ConvertAsciiToHex(byte lucInput)
        {
            if ('0' <= lucInput && lucInput <= '9')
                return (byte)(lucInput - '0');

            if ('a' <= lucInput && lucInput <= 'f')
                return (byte)((lucInput - 'a') + 10);

            if ('A' <= lucInput && lucInput <= 'F')
                return (byte)((lucInput - 'A') + 10);

            return (byte)0;
        }


        private int CreatePacket(ref byte[] pktBuf, ref byte[] tempBuf, int pktLen)
        {
            System.UInt16 current_crc_value;
            byte final_crc_msb, final_crc_lsb;

            pktBuf[0] = 0x01;//SOF
            pktBuf[2] = 0;//len, msb
            pktBuf[3] = 0x10;//device type
            //copy the flag, command and data to pktBuf

            for (int i = 0; i < pktLen; i++)
            {
                pktBuf[i + 4] = tempBuf[i];
            }

            pktLen += 4;
            pktBuf[1] = (byte)(pktLen + 2);
            current_crc_value = lrc(ref pktBuf, pktLen);
            final_crc_msb = (byte)((0xFF00 & current_crc_value) >> 8);
            final_crc_lsb = (byte)(0x00FF & current_crc_value);
            pktBuf[pktLen++] = final_crc_lsb;
            pktBuf[pktLen++] = final_crc_msb;

            return pktLen;
        }

        System.UInt16 lrc(ref byte[] message, int length)
        {
            int i;
            System.UInt16 temp1 = 0, temp2 = 0;

            for (i = 0; i < length; i++)
            {
                temp2 ^= message[i];
            }
            temp1 = (System.UInt16)(temp2 ^ 0xff);

            return ((System.UInt16)((temp1 << 8) | temp2));
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            byte[] sbuffer = new byte[255];
            int sindex = 0;
            int count = 16;
            
            if (readData(sbuffer))
            {
                while ((count != 0) && (receiveIndex < (RECBUFMAX - 5)))
                {
                    receiveBuffer[receiveIndex++] = sbuffer[sindex++];
                    count--;
                }
                if ((receiveIndex > 3) &&
                    (receiveBuffer[0] == 0x01) &&
                    (receiveBuffer[2] == 0) &&
                    (receiveBuffer[1] <= receiveIndex))
                {
                    DisplayReceived();
                    MyKillTimer();
                }
            }
            else
            {
                guiTimerCount++;
                if (guiTimerCount > 5)
                {
                    textBoxReceive.Text += " nothing received";
                    MyKillTimer();
                }
            }
        }

        private void DisplayReceived()
        {
            string tempbuf = "";
            byte lucCmd, lucErrorCode;
            byte index;
            int temp_length;
            byte lucPktLen;
            byte byte_len;
            
            index = 0;
            while (index < receiveBuffer[1])
            {
                if (receiveBuffer[index] < 0x10)
                    tempbuf += string.Format("0{0:X} ", receiveBuffer[index]);
                else
                    tempbuf += string.Format("{0:X} ", receiveBuffer[index]);
                index++;
            }
    

            lucErrorCode = receiveBuffer[4];
            lucCmd = receiveBuffer[5];
            lucPktLen = receiveBuffer[1];
            temp_length = 0;
    
            if (lucErrorCode == 0)
            {
                switch (lucCmd)
                {
                    case 0x01:
                        tempbuf += "\r\nUID: ";
                        temp_length = 8;
                        index = 15;
                        while (temp_length != 0)
                        {
                            if (receiveBuffer[index] < 0x10)
                                tempbuf += string.Format("0{0:X} ", receiveBuffer[index]);
                            else
                                tempbuf += string.Format("{0:X} ", receiveBuffer[index]);
                            index--;
                            temp_length--;
                        }
                        break;

                    case 0x20:
                        temp_length = 4;
                        index = 6;
                        tempbuf += "\r\nData: ";
                        while (temp_length != 0)
                        {
                            if (receiveBuffer[index] < 0x10)
                                tempbuf += string.Format("0{0:X} ", receiveBuffer[index]);
                            else
                                tempbuf += string.Format("{0:X} ", receiveBuffer[index]);
                            index++;
                            temp_length--;
                        }
                        tempbuf += "\r\nBlock: ";
                        index = 11;
                        if (receiveBuffer[index] < 0x10)
                            tempbuf += string.Format("0{0:X} ", receiveBuffer[index]);
                        else
                            tempbuf += string.Format("{0:X} ", receiveBuffer[index]);
                        break;

                    case 0x23://read multi-block
                        tempbuf += "\r\nread multi-block:\r\n";
                        index = 8;
                        byte_len = 0;
                        while (index < (lucPktLen-2))
                        {
                            if (receiveBuffer[index] < 0x10)
                                tempbuf += string.Format("0{0:X} ", receiveBuffer[index]);
                            else
                                tempbuf += string.Format("{0:X} ", receiveBuffer[index]);
                            index++;
                            byte_len++;
                            if (byte_len == 5)
                            {
                                tempbuf += "\r\n";
                                byte_len = 0;
                            }
                            //01 32 00 10 00 23 00 08  00 11 00 00 00 01 11 00 00 11 02 11 00 00 22 03 11 00 00 33 04 11 00 00 44 05 11 00 00 55 06 11 00 00 66 07 11 00 00 77 08 F7 
                        }
                        break;
                    
                    
                    case 0xE0:
                        tempbuf += "\r\nVersion: ";
                        //01 14 00 10 00 E0 01 05 07 02 FF FF FF FF FF FF FF FF E4 1B
                        tempbuf += receiveBuffer[7].ToString() + ".0" + receiveBuffer[6].ToString();
                        break;

                    default:

                        break;
                }
            }
            textBoxReceive.Text += tempbuf;
        }


        protected override void WndProc(ref Message m)
        {
            const uint WM_CREATE = 0x00000001;
            const uint WM_DEVICECHANGE = 0x00000219;
            const uint DBT_DEVICEARRIVAL = 0x00008000;
            const uint DBT_DEVICEREMOVECOMPLETE = 0x00008004;
            int isOurDevice;

            switch ((uint)m.Msg)
            {
                case WM_CREATE:
                    OnInitDialog(ref m);
                    break;

                case WM_DEVICECHANGE:

                    switch ((uint)m.WParam)
                    {
                        case DBT_DEVICEARRIVAL:

                            // Do what you need to do.
                            isOurDevice = isMyDeviceNotification((UInt32)m.LParam);
                            if((isOurDevice != 0) && IsConnected) {
                                //here we should ask if isOurDevice is not zero. 
                                //Unfortunately the value returned by this function is always zero. 
                                //Are we missing something?
                                textBoxStatus.Text = "Our Device Already Connected.";
                                IsConnected = true;
                            } else {
                                textBoxStatus.Text = "A device has been inserted and is now available.";
                                ConnectDevice();
                            }
                            break;

                        case DBT_DEVICEREMOVECOMPLETE:
                            isOurDevice = isMyDeviceNotification((UInt32)m.LParam);
                            if ((isOurDevice != 0) && IsConnected)
                            {
                                closeDevice();
                                textBoxStatus.Text = "A device has been removed.";
                                IsConnected = false;
                            }
                            else
                            {
                                textBoxStatus.Text = "Device may have been removed without closing.";
                            }
                            break;

                        default:
                            textBoxStatus.Text = "OnDeviceChange : default";
                            break;
                    }

                    break;

            }

            base.WndProc(ref m);

        }

        private void OnInitDialog(ref Message m)
        {
            hWndParent = m.HWnd;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            OnCancel();
        }

        private void OnCancel()
        {
            if (IsConnected) //if our device is attached
            {
                closeDevice();//close all handles
                MyKillTimer();//close the timer
            }
            hidUnregisterDeviceNotification(hWndParent);
        }


        private void RegisterHidNotification()
        {
            Win32.DEV_BROADCAST_DEVICEINTERFACE dbi = new
            Win32.DEV_BROADCAST_DEVICEINTERFACE();
            int size = Marshal.SizeOf(dbi);
            dbi.dbcc_size = size;
            dbi.dbcc_devicetype = Win32.DBT_DEVTYP_DEVICEINTERFACE;
            dbi.dbcc_reserved = 0;
            dbi.dbcc_classguid = Win32.GUID_DEVINTERFACE_HID;
            dbi.dbcc_name = 0;
            IntPtr buffer = Marshal.AllocHGlobal(size);
            Marshal.StructureToPtr(dbi, buffer, true);
            IntPtr r = Win32.RegisterDeviceNotification(Handle, buffer,
            Win32.DEVICE_NOTIFY_WINDOW_HANDLE);
            if(r == IntPtr.Zero)
                textBoxStatus.Text = Win32.GetLastError().ToString();
        }


        public string Buffer
        {
            get
            {
                return strBuffer;
            }
            set
            {
                strBuffer = value;
            }
        }

        private void connectToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
        }

        private void disconnectToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (IsConnected) //if our device is attached
            {
                closeDevice();//close all handles
                MyKillTimer();//close the timer
                textBoxStatus.Text = "Disconnect";
            }
        }

    }

    class Win32
    {
        public const int
        WM_DEVICECHANGE = 0x0219;
        public const int
        DBT_DEVICEARRIVAL = 0x8000,
        DBT_DEVICEREMOVECOMPLETE = 0x8004;
        public const int
        DEVICE_NOTIFY_WINDOW_HANDLE = 0,
        DEVICE_NOTIFY_SERVICE_HANDLE = 1;
        public const int
        DBT_DEVTYP_DEVICEINTERFACE = 5;
        public static Guid
        GUID_DEVINTERFACE_HID = new
        Guid("4D1E55B2-F16F-11CF-88CB-001111000030");

        [StructLayout(LayoutKind.Sequential)]
        public class DEV_BROADCAST_DEVICEINTERFACE
        {
            public int dbcc_size;
            public int dbcc_devicetype;
            public int dbcc_reserved;
            public Guid dbcc_classguid;
            public short dbcc_name;
        }

        [DllImport("user32.dll", SetLastError = true)]
        public static extern IntPtr RegisterDeviceNotification(
        IntPtr hRecipient,
        IntPtr NotificationFilter,
        Int32 Flags);

        [DllImport("kernel32.dll")]
        public static extern int GetLastError();
    }




    
}